//-----------------------------------------------------//
// Test appli for usb Ver2.3
// 
// tdbdusb_app.cpp
//-----------------------------------------------------//

/*----------------------------------------------------*/
// Include                                            //
/*----------------------------------------------------*/
#ifdef _LINUX_DEF_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include "sinichapp.h"



#else

#include "stdafx.h"
#include <windows.h>
#include <setupapi.h>
#include <winioctl.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>
#include "sinich_cmn.h"
#include "sinich_lib.h"

#endif


#include "sinich_cmn.h"
#include "sinich_lib.h"


/*----------------------------------------------------*/
// Definition                                         //
/*----------------------------------------------------*/
#define ENDIAN_SET		SINICH_LITTLE_ENDIAN
#define ICH_SYS_DEFAULT_DELAY 1000
//#define ALLREG_ACEESS 1
#define	MODE_16CH	0

//#define _DIRECT_WRITE_ (1)

/*----------------------------------------------------*/
// Prototype                                          //
/*----------------------------------------------------*/
int DisplayAudioSampleRate(uchar msg_flag, uchar fpga_rdata);
int codec_control_set(uchar msg_flag, struct ich_io_t *io,int set_gain_val);
void insert_delay(uint delay);
int hex_check(char *hex_char);
int ahextoi(char hex);
int ahextoi2(char *hex_char, int digit);
int DisplayDescriptors(HANDLE hDev);
int arg_check(int argc, char *argv[], int argnum_now, int mode);




/*----------------------------------------------------*/
// Global value                                       //
/*----------------------------------------------------*/
#ifdef _LINUX_DEF_
uchar device_name[64] = "/dev/sinichusb0";
#else
char device_name[64] = "Ezusb-0";
#endif // #ifdef _LINUX_DEF_

unsigned char	audio_board_num_table[] = { 0x5A, 0xA5, 0x4B, 0xB4 };
unsigned long	ich_header[4]={0x10000000,0,0,0};

unsigned long	audio_outpkt_tbl[7]={
				1536,	// 48k
				1024,	// 32k
				512,	// 16k
				256,	// 8k
				1536,	// 44.1k
				768,	// 22.05k
				384		// 11.025k
				};

unsigned long	audio_inpkt_tbl[7]={
				6144,	// 48k
				4096,	// 32k
				2048,	// 16k
				1024,	// 8k
				6144,	// 44k
				3072,	// 22k
				1536	// 11k
				};


/*----------------------------------------------------*/
// Main process                                       //
/*----------------------------------------------------*/

int main(int argc, char* argv[])
{

	FILE *hfile_audio_in = NULL, *hfile_audio_out = NULL;

	int i=1, cnt, ret,ret_val=-1;
	int ver;
	struct ich_io_t *ted_usb_sys=NULL;

	char audio_in_name[512];
	char audio_out_name[512];
	char reg_rd_addr_name[128];
	char reg_wr_addr_name[128];
	char reg_wr_data_name[128];
	char audio_gain_set_name[128];
	uchar sync_mode=0;

	int samp_au=0;
	int reg_rd_addr=0, reg_wr_addr=0 ,set_gain_val=0;
	uchar fpga_rdata=0;
	unsigned char sample_rate_ch_set=0;
	unsigned long status = 0;
	ushort buff_status=0;

	uint fpos_start, fpos_end;
	int fsize=0, msize=0;
	int audio_inpkt_siz=0, audio_outpkt_siz=0;
	int audioin_count=0,  audioin_count_org=0;
	int audioout_count=0, audioout_count_org=0;

	unsigned long audio_head[4];

	int audio_in=0, audio_out=0;
	UCHAR *audio_in_buf=NULL, *taudio_in_buf=NULL;
	UCHAR *audio_out_buf=NULL, *taudio_out_buf=NULL;
	int audio_buffer_flush=0;

	int com_reg_read=0, com_reg_write=0;
	uchar message_print_mode = 0;
	uchar descriptor_print_mode = 0;
	uchar set_gain_mode = 0;

	uchar ep4_buffspace_num=0;
	uchar ep2_bufffill_num=0;



	memset(audio_in_name, 0x00, sizeof(audio_in_name));
	memset(audio_out_name, 0x00, sizeof(audio_out_name));
	memset(reg_rd_addr_name, 0x00, sizeof(reg_rd_addr_name));
	memset(reg_wr_addr_name, 0x00, sizeof(reg_wr_addr_name));
	memset(reg_wr_data_name, 0x00, sizeof(reg_wr_data_name));

	// main disp
	printf("-------------------------------------------\n");
	printf("     TD-BD-USBIF test(audio in/out)    \n");
	printf("-------------------------------------------\n");

	if(argc < 2){
		printf("Please input paramater as argument!\n");
		printf(" xxxx -0 samp_au ich_file loop_au\n");
		printf(" xxxx -1 och-file\n");
		printf(" xxxx -2 reg_addr\n");
		printf(" xxxx -3 reg_addr reg_data\n");
		printf(" xxxx -g gain\n");
		printf(" xxxx -s sync_mode\n");
		printf(" samp_au   = 0:48k/1:32k/2:16k/3:8k/4:44.1k/5:22k/6:11k\n");
		printf(" loop_au   = audio read loop count\n");
		printf(" ich_file  = ich file is audio capture file.\n");
		printf(" och_file  = och file is audio play    file.\n");
		printf(" gain      = 0x00-0x60\n");
		printf(" sync_mode = sync mode\n");
		return (0);
	}

	// argument check
	while(1){
		if(argv[i][0]=='-'){
			switch(argv[i++][1]){
				case '0':
					ret = arg_check(argc, argv, i, 0);
					if(ret != 0) goto END_PROC;
					samp_au = atoi(argv[i++]);
					if(samp_au > 7) {printf("Error : Invalid input parameter [samp_au = not (0-6)]\n"); goto END_PROC;}
					strcpy(audio_in_name,argv[i++]);
					audioin_count=audioin_count_org=atoi(argv[i++]);
					audio_buffer_flush = 1;
					break;
				case '1':
					ret = arg_check(argc, argv, i, 1);
					if(ret != 0) goto END_PROC;
					strcpy(audio_out_name,argv[i++]);
					break;
				// register read command
				case '2':
					ret = arg_check(argc, argv, i, 2);
					if(ret != 0) goto END_PROC;
					com_reg_read = 1;
					strcpy(reg_rd_addr_name, argv[i++]);
					break;
				// register write command
				case '3':
					ret = arg_check(argc, argv, i, 3);
					if(ret != 0) goto END_PROC;
					com_reg_write = 1;
					strcpy(reg_wr_addr_name, argv[i++]);
					strcpy(reg_wr_data_name, argv[i++]);
					break;
				// print message mode
				case 'p':
				case 'P':
					message_print_mode = 1;
					break;
				case 'd':
				case 'D':
					descriptor_print_mode = 1;
					break;
				case 'g':
				case 'G':
					ret = arg_check(argc, argv, i, 4);
					if(ret != 0) goto END_PROC;
					set_gain_mode = 1;
					strcpy(audio_gain_set_name,argv[i++]);
					break;
				case 's':
				case 'S':
					sync_mode = 1;
					break;
				default:
					printf("Invalid identifier code !\n");
					return (0);
					break;
			}
		}
		if(argc <= i) break;
	}

	// audio flg set
	if(audio_in_name[0]  != '\0') audio_in =1;
	if(audio_out_name[0] != '\0') audio_out=1;

	//-- Driver open for control transfer(EP0) --//
	if((ret_val = sinich_sys_open(&ted_usb_sys, device_name)) != 0){
		printf("Driver open error!\n");
		goto END_PROC;
	}
	//-- Version read --//
	if((ver = sinich_sys_get_fpga_version(ted_usb_sys)) < 0){
		printf("Get fpga-version error! :%d\n", ver);
		goto END_PROC;
	}else printf("Fpga   version             : 0x%02X\n", (uchar)ver);
	if((ver=sinich_sys_get_driver_version(ted_usb_sys)) < 0){
		printf("Get driver-version!\n");
		goto END_PROC;
	}else printf("Driver version             : 0x%08X\n", (uint)ver);


	/*---------------------------------------------------------------*/
	/*----------------------*/
	/*	Register read	 	*/
	/*----------------------*/
	if(com_reg_read){
		//-- Audio,I/O test is invalid --//
		audio_in = 0;
		audio_out= 0;

		//-------------------------------//
		ret_val = hex_check(reg_rd_addr_name);
		if (ret_val != 0) {com_reg_read = 0; goto END_REG_READ;}
		reg_rd_addr = ahextoi2(reg_rd_addr_name, 4);
		if (reg_rd_addr == -1) {com_reg_read = 0; goto END_REG_READ;}
		if (reg_rd_addr_name[3] == '8') {
			ret_val = sinich_sys_get_reg(ted_usb_sys, reg_rd_addr, &fpga_rdata);
			if (ret_val != 0) {com_reg_read = 0; goto END_REG_READ;}
		}else {
//-- 0x40xx - 0x47xx : support --//
#ifdef ALLREG_ACEESS
			ret_val = sinich_sys_get_allreg(ted_usb_sys, reg_rd_addr, &fpga_rdata);
			if (ret_val != 0) {com_reg_read = 0; goto END_REG_READ;}
			goto END_REG_READ;
#endif 


//-- 0x40xx - 0x47xx : no support --//
			printf("Error : Please input system board register(0x48xx)\n\n");
			goto END_PROC;
		}
END_REG_READ :
		if (com_reg_read) printf("\nRegister read  OK     Address : 0x%04X, Data : 0x%02X\n\n", reg_rd_addr, fpga_rdata);
		else printf("\nRegister read  NG     Address : 0x%04X, Data : ----\n\n", reg_rd_addr);
		goto END_PROC;
	}

	/*---------------------------------------------------------------*/
	/*----------------------*/
	/*	Register write		*/
	/*----------------------*/
	if(com_reg_write){
		//-- Audio,I/O test is invalid --//
		audio_in = 0;
		audio_out= 0;

		//-------------------------------//
		ret_val = hex_check(reg_wr_addr_name);
		if (ret_val != 0) {com_reg_write = 0; goto END_REG_WRITE;}
		ret_val = hex_check(reg_wr_data_name);
		if (ret_val != 0) {com_reg_write = 0; goto END_REG_WRITE;}
		reg_wr_addr = ahextoi2(reg_wr_addr_name, 4);
		if (reg_wr_addr == -1) {com_reg_write = 0; goto END_REG_WRITE;}
		fpga_rdata = ahextoi2(reg_wr_data_name, 2);
		if (reg_wr_addr_name[3] == '8') {
			ret_val = sinich_sys_set_reg(ted_usb_sys, reg_wr_addr, fpga_rdata);
			if (ret_val != 0) {com_reg_write = 0; goto END_REG_WRITE;}
		}else {
//-- 0x40xx - 0x47xx : support --//
#ifdef ALLREG_ACEESS
			ret_val = sinich_sys_set_allreg(ted_usb_sys, reg_wr_addr, fpga_rdata);
			if (ret_val != 0) {com_reg_read = 0; goto END_REG_WRITE;}
			goto END_REG_WRITE;
#endif 

//-- 0x40xx - 0x47xx : no support --//
			printf("Error : Please input system board register(0x48xx)\n\n");
			goto END_PROC;
		}
END_REG_WRITE:
		if (com_reg_write) printf("\nRegister write OK     Address : 0x%04X, Data : 0x%02X\n\n", reg_wr_addr, fpga_rdata);
		else printf("\nRegister write NG     Address : 0x%04X, Data : ----\n\n", reg_wr_addr);
		goto END_PROC;

	}

	/*---------------------------------------------------------------*/
	/*----------------------*/
	/*	Audio gain set	 	*/
	/*----------------------*/
	if(set_gain_mode){

		ret_val = hex_check(audio_gain_set_name);
		if (ret_val != 0) {
			printf("Please set hex number as audio gain !!\n");
			set_gain_mode = 0;
			goto END_PROC;
		}
		set_gain_val = ahextoi2(audio_gain_set_name, 2);
		if (set_gain_val == -1) {
			printf("Please set 2 digits hex number as audio gain !!\n");
			set_gain_mode = 0;
			goto END_PROC;
		}
		if (set_gain_val > 0x60){
			printf("Please set correct gain data value [0x00-0x60] !\n");
			set_gain_mode = 0;
			goto END_PROC;
		}

		printf("Audio gain data            : 0x%02x\n", set_gain_val);

	}


	/*---------------------------------------------------------------*/
	/*--------------------------*/
	/*	Prepare audio in-data 	*/
	/*--------------------------*/
	/* Get input pkt size */

	if(audio_in){
		audio_inpkt_siz=audio_inpkt_tbl[samp_au];
		audio_inpkt_siz+=4;

#ifdef _DIRECT_WRITE_
		// Allocate read buffer
		if((audio_in_buf=taudio_in_buf=(UCHAR *)malloc( /*audioin_count*/32*audio_inpkt_siz ))==NULL){
			printf("Read buffer allocate error (1)!\n");
			return (0);
		}
#else
		// Allocate read buffer
		if((audio_in_buf=taudio_in_buf=(UCHAR *)malloc( audioin_count*audio_inpkt_siz ))==NULL){
			printf("Read buffer allocate error (2)!\n");
			return (0);
		}
#endif

		/* Write och header */
		ich_header[1] = samp_au;
		ich_header[2] = MODE_16CH;
	}
	/*---------------------------------------------------------------*/

	/*--------------------------*/
	/*	Prepare audio out-data 	*/
	/*--------------------------*/
	if(audio_out){
		if((hfile_audio_out = fopen(audio_out_name, "rb")) == NULL){
			printf("OCH file open error!\n");
			goto END_PROC;
		}
		/* Read och header */
		if(fread(audio_head, sizeof(uchar), 0x10, hfile_audio_out)!= 0x10){
			printf("File read error!\n");
			goto END_PROC;
		}
		if(audio_in){
			/* Check in/out sampling code */
			if(audio_head[1] != (unsigned )samp_au){
				printf("Missmatch in/out sampling freq code !\n");
				goto END_PROC;
			}
		}
		samp_au=audio_head[1];
		/* Get output pkt size */
		audio_outpkt_siz=audio_outpkt_tbl[samp_au];
		/* Get och file size */
		fseek(hfile_audio_out, 0, SEEK_SET);
		fpos_start = ftell(hfile_audio_out);
		fseek(hfile_audio_out, 0, SEEK_END);
		fpos_end = ftell(hfile_audio_out);
		fsize=(int)(fpos_end - fpos_start);
		fseek(hfile_audio_out, 0x10 , SEEK_SET);
		fsize-=4;//???
		msize=(fsize/audio_outpkt_siz)*audio_outpkt_siz;

		// Read memory allocate 
		if((audio_out_buf=taudio_out_buf=(UCHAR *)malloc( msize ))==NULL){
			printf("Write buffer allocate error!\n");
			goto END_PROC;
		}
		/* Read pcm data */
		if(fread(audio_out_buf, sizeof(uchar), msize, hfile_audio_out) == 0){
			printf("File read error!\n");
			goto END_PROC;
		}
		audioout_count=audioout_count_org=msize/audio_outpkt_siz;
	}
	/*---------------------------------------------------------------*/

	if(audio_in | audio_out){
		//--       Driver Open        --//
		//--       Driver Open End    -- //
		/*---------------------------------------------------------------*/
		//-- Set sampling rate & channel(Audio) --//
		sample_rate_ch_set |= samp_au;	
		sample_rate_ch_set |= (MODE_16CH<<3);

		if((ret_val = sinich_pcm_ctl(ted_usb_sys,sample_rate_ch_set)) != 0){
			printf("We can't set sampling status!");
			goto END_PROC;
		}
		if((ret_val = sinich_sys_get_reg( ted_usb_sys, 0x01, &fpga_rdata)) != 0){
			printf("We can't get sampling status!");
			goto END_PROC;
		}

	
		DisplayAudioSampleRate(message_print_mode, fpga_rdata);

		//-- Set codec parameter --//
		if((ret_val = sinich_sys_set_reg(ted_usb_sys,0x0B,0x01)) != 0){
			printf("Register set error!\n");
			goto END_PROC;
		}

		//-- Check slave board connection --//
		ret_val = codec_control_set(message_print_mode, ted_usb_sys,set_gain_val);
		if(ret_val < 0) goto END_PROC;

		//-- If already EP4 START, EP4 STOP --//
		if((ret_val = sinich_sys_get_reg( ted_usb_sys, 0x04, &fpga_rdata)) != 0){
			printf("Reg Read Error!\n");
			goto END_PROC;
		}
		if(fpga_rdata){
			ret_val = sinich_sys_set_reg( ted_usb_sys, 0x04, 0x00);
			if (ret_val!=0){
				printf("Set audio in enable register failed\n");
				goto END_PROC;
			}
		}

		//-- If already EP2 START, EP2 STOP --//
		if((ret_val = sinich_sys_get_reg( ted_usb_sys, 0x03, &fpga_rdata)) != 0){
			printf("Reg Read Error!\n");
			goto END_PROC;
		}
		if(fpga_rdata){
			ret_val = sinich_sys_set_reg( ted_usb_sys, 0x03, 0x00);
			if (ret_val!=0){
				printf("Set audio out enable register failed\n");
				goto END_PROC;
			}
		}

		if(audio_out){
			ret=sinich_pcm_write( ted_usb_sys, taudio_out_buf, audio_outpkt_siz*4);
			if(ret < 0){ printf("PCM Write Size Error %d\n",ret); goto END_PROC;}
			taudio_out_buf+=ret;
			audioout_count-=(ret/audio_outpkt_siz);
		}
	}


	/*---------------------------------------------------------------*/
	/*----------------------*/
	/*	Display dscriptors  */
	/*----------------------*/
	if(descriptor_print_mode){
		ret_val = DisplayDescriptors(ted_usb_sys->dev);
		if(ret_val == -1){
			printf("Get USB device descriptor error!\n");
			goto END_PROC;
		}
	}

#ifdef _DIRECT_WRITE_
	if(audio_in){
		unlink(audio_in_name);
		if((hfile_audio_in = fopen(audio_in_name, "wb")) == 0){
			printf("File ich open error!\n");
			goto END_PROC;
		}
		//-- Flash read buffer --//
		if(fwrite(ich_header, sizeof(uchar), 16, hfile_audio_in)!=16){
			printf("File ich write error!\n");
			goto END_PROC;
		}
	}
#endif

	//-- Audio In Start --//
	if(sync_mode){
		printf("sync mode\n");
	}
	else{
		if(audio_in){
			printf("capture\n");
			audio_buffer_flush = 1;
		}
		if(audio_out){
			printf("play\n");
		}
	}

	printf("\nPress enter key to test!\n");
	//SetPriorityClass(GetCurrentProcess(),HIGH_PRIORITY_CLASS);
	getchar();

	if(sync_mode){
		if(sinich_all_start(ted_usb_sys)==-1){
			printf("Audio sync start error !!\n");
			goto	END_PROC;
		}
	}
	else{
		if(sinich_sys_start(ted_usb_sys)==-1){
			printf("Audio in start error !\n");
			goto	END_PROC;
		}
	}

	//-- Data receive/send process start --//
	while(1){
		if((audio_in==0)&&(audio_out==0)) break;

		//-- Wait status (ich_wait_status function)	060706 nakamura --//
		if((buff_status = sinich_sys_status(ted_usb_sys)) == 0xFFFF){
			printf("Status read error !\n");
			goto	END_PROC;
		}

		//-- get buff status --//
		ep2_bufffill_num = (uchar)buff_status;
		ep4_buffspace_num = (uchar)(buff_status>>8);

//		if(ep2_bufffill_num>12) printf("%04x:\n",buff_status);

		//-- PCM data write process(EP4) --//
		if(ep4_buffspace_num){
			if(audio_out){
				if( ep4_buffspace_num > audioout_count ) ep4_buffspace_num = audioout_count;
				ret=sinich_pcm_write( ted_usb_sys, taudio_out_buf, audio_outpkt_siz*ep4_buffspace_num);
				if(ret < 0){ printf("PCM Write Size Error %d\n",ret); break;}
				taudio_out_buf+=ret;
				audioout_count-=(ret/audio_outpkt_siz);
				if( audioout_count <=0){
					audio_out=0;
				}
			}
		}

		//-- PCM data receive process(EP2) --//
		if(ep2_bufffill_num){
			if(audio_in){
				if( ep2_bufffill_num > audioin_count ) ep2_bufffill_num=audioin_count;
				ret=sinich_pcm_read( ted_usb_sys, taudio_in_buf, audio_inpkt_siz*ep2_bufffill_num);
				if(ret < 0){printf("PCM read size error %d\n",ret); break;}
#ifdef _DIRECT_WRITE_ 
				if(fwrite((const void*)taudio_in_buf, sizeof(uchar), ret, hfile_audio_in)!=(unsigned int)ret){
					printf("File ich write error!\n");
					break;
				}
#else
				taudio_in_buf+=ret;
#endif
				audioin_count-=(ret/audio_inpkt_siz);
				if(audioin_count <= 0){
					audio_in=0;
				}
			}
		}
	}

	printf("\n");

	printf("Success send/receive data to/from buffer!!\n");

#ifndef _DIRECT_WRITE_ 
	// Flash
	if(audio_buffer_flush){
		unlink(audio_in_name);
		if((hfile_audio_in = fopen(audio_in_name, "wb")) == 0){
			printf("File ich open error!\n");
			goto END_PROC;
		}
		//-- Flash read buffer --//
		if(fwrite(ich_header, sizeof(uchar), 16, hfile_audio_in)!=16){
			printf("File ich write error!\n");
			goto END_PROC;
		}
		if(fwrite((const void*)audio_in_buf, sizeof(uchar), audio_inpkt_siz*audioin_count_org, hfile_audio_in)!=(unsigned int)audio_inpkt_siz*audioin_count_org){
			printf("File ich write error!\n");
			goto END_PROC;
		}
		printf("Success write audio data in file!!\n");
	}
#endif

END_PROC:
	if(sync_mode){			sinich_all_stop(ted_usb_sys);}
	else if(ted_usb_sys!=NULL){	sinich_sys_stop(ted_usb_sys);}

	if(ted_usb_sys!=NULL)		sinich_sys_close(ted_usb_sys);

	if(audio_in_buf !=NULL)		free(audio_in_buf);
	if(audio_out_buf!=NULL)		free(audio_out_buf);
	if(hfile_audio_in!=NULL)	fclose(hfile_audio_in);
	if(hfile_audio_out!=NULL)	fclose(hfile_audio_out);

	printf("Press enter key to finish\n");
	getchar();

	return 0;

}

/*----------------------------------------------------*/
// Display current sampling rate & ch (Audio)         //
/*----------------------------------------------------*/
int DisplayAudioSampleRate(uchar msg_flag, uchar fpga_rdata)
{
	int samplerate;
	char data_endian[64] = {0};

	// Sampling rate selection //
	if ((fpga_rdata&0x07) ==  AUDIO_48K){
		samplerate = 48000;
	} else if((fpga_rdata&0x07) ==  AUDIO_32K){
		samplerate = 32000;
	} else if((fpga_rdata&0x07) ==  AUDIO_16K){
		samplerate = 16000;
	} else if((fpga_rdata&0x07) ==  AUDIO_8K){
		samplerate = 8000;
	} else if((fpga_rdata&0x07) ==  AUDIO_44K){
		samplerate = 44100;
	} else if((fpga_rdata&0x07) ==  AUDIO_22K){
		samplerate = 22050;
	} else{ // fpga_rdata&0x07 ==  AUDIO_11K
		samplerate = 11025;
	}

	// Audio data endian selection //
	if((fpga_rdata&0x20) == 0){
		strcpy(data_endian,"Little Endian");
	} else {
		strcpy(data_endian,"Big Endian");
	}

	printf("Data endian                : %s\n",data_endian);
	printf("Audio sampling frequency   : %dHz\n",samplerate);

	return 0;
}

/*----------------------------------------------------*/
// Display connect audio board                        //
/*----------------------------------------------------*/
int codec_control_set(uchar msg_flag, struct ich_io_t *io,int set_gain_val)
{
	int ret;
	struct codec_param_t	codec[4];
	uchar fpga_rdata;

	if((ret	= sinich_sys_act_info(io ,0 ,&fpga_rdata)) < 0){
		printf("===== Audio board nothing! (ret(%d)<0) ===== \n", ret);
	}else{
		if( (unsigned char)fpga_rdata == audio_board_num_table[0] ){
			printf("===== Audio board act! ===== \n");
			// Power down on
			codec[0].act_flag		= 0x0002;	// Bit1 set
			codec[0].adc_power_down	= 0;
			if((ret	= sinich_pcm_set_codec(io ,0 ,&codec[0])) < 0 ){
				printf("Codec set error!\n");
				return(-1);
			}
			Sleep(10);	// 10ms sleep
			// Power down off
			codec[0].act_flag		= 0x0002;	// Bit1 set
			codec[0].adc_power_down	= 1;
			if((ret	= sinich_pcm_set_codec(io ,0 ,&codec[0])) < 0 ){
				printf("Codec set error!\n");
				return(-1);
			}

			// Wait for ADC initialize end(Addtional function 2006/06/23)
			codec[0].act_flag = 0x0200;
			while(1){
				ret	= sinich_pcm_get_codec(io , 0 ,codec);
				if(ret < 0) {
					printf("Codec initialize status read error!!\n");
					return(-1);
				}
				if(((codec[0].operation_mode) & 0x08) != 0){
					break;
				}
			}

			if(set_gain_val != 0){
				// Set Gain(IPGA/ALC Mode Control 2)
				Sleep(100);	// 100ms sleep
				codec[0].act_flag		   = 0x0500;	// Set gain bit
				codec[0].input_pga_control = set_gain_val; // IPGA data
				codec[0].alc_mode_control2 = set_gain_val;		   // ALC Mode Control2 data
				if((ret	= sinich_pcm_set_codec(io ,0 ,&codec[0])) < 0 ){
					printf("Codec set error!\n");
					return(-1);
				}
			}

			if (msg_flag)
			{// For debug
				int		cnt1;
				int		cnt2;
				codec[0].act_flag		= 0x1FFF;	// All read
				codec[1].act_flag		= 0x1FFF;	// All read
				codec[2].act_flag		= 0x1FFF;	// All read
				codec[3].act_flag		= 0x1FFF;	// All read
				ret	= sinich_pcm_get_codec(io , 0 ,codec);
				if( ret < 0 ){
					printf("Get codec info error!\n");
					return(-1);
				}else{
					for( cnt1=0 ; cnt1<4 ; cnt1++ ){
						for( cnt2=0 ; cnt2<0x0C ; cnt2++ ){
							printf("Address 0x%02X : Data 0x%02X\n",
								cnt2,*(((unsigned char *)&codec[cnt1])+cnt2));
						}
					}
				}
			}// For debug
		}
	}


	return 0;
}

/*----------------------------------------------------*/
// Delay,Hex checker,ASCII to Integer change          //
/*----------------------------------------------------*/
void insert_delay(uint delay)
{
	volatile uint count_down;

	for (count_down = delay; count_down > 0; count_down--);
}

// check argument header is hexadecimal or not
int hex_check(char *p)
{
	if (('0' != p[0]) || !(('x' == p[1]) || 'X' == p[1])) {
		return -1;
	}
	
	return 0;
}

// Alphabet Hexadecimal number charactor to Integer
int ahextoi(char hex)
{
	if ((hex >= '0') && (hex <= '9')) return (hex - '0');
	else if ((hex >= 'a') && (hex <= 'f')) return (hex + 10 - 'a');
	else if ((hex >= 'A') && (hex <= 'F')) return (hex + 10 - 'A');

	return -1;
}

// Alphabet Hexadecimal number charactor to Integer
int ahextoi2(char *hex_char, int digit)
{
	int base = 1, var, ret = 0;

	digit++;
	while(digit != 1) {
		var = ahextoi(hex_char[digit--]);
		if ((var<0) || (var>15)) {
			return -1;
		}
		ret += var * base;
		base <<= 4;
	}

	return ret;
}

/*----------------------------------------------------*/
// Display each descriptors                           //
/*----------------------------------------------------*/
int DisplayDescriptors(HANDLE hDev)
{
	USB_DEVICE_DESCRIPTOR dsc;
	int ret_val = -1;

	ret_val = get_device_descriptor(hDev, &dsc);
	if (ret_val == -1) return (-1);

	printf("\n");
	printf("bLength            0x%02X\n", dsc.bLength);
	printf("bDescriptorType    0x%02X\n", dsc.bDescriptorType);
	printf("bcdUSB             0x%04X\n", dsc.bcdUSB);
	printf("bDeviceClass       0x%02X\n", dsc.bDeviceClass);
	printf("bDeviceSubClass    0x%02X\n", dsc.bDeviceSubClass);
	printf("bDeviceProtocol    0x%02X\n", dsc.bDeviceProtocol);
	printf("bMaxPacketSize0    0x%02X\n", dsc.bMaxPacketSize0);
	printf("idVendor           0x%04X\n", dsc.idVendor);
	printf("iProduct           0x%04X\n", dsc.iProduct);
	printf("bcdDevice          0x%04X\n", dsc.bcdDevice);
	printf("iManufacturer      0x%02X\n", dsc.iManufacturer);
	printf("iProduct           0x%02X\n", dsc.iProduct);
	printf("iSerialNumber      0x%02X\n", dsc.iSerialNumber);
	printf("bNumConfigurations 0x%02X\n", dsc.bNumConfigurations);

	return(0);
}

/*----------------------------------------------------*/
// Argument check                                     //
/*----------------------------------------------------*/
int arg_check(int argc ,char *argv[], int argnum_now, int mode)
{
	int i;

	if(mode == 0){
		for(i = 0; i < 3; i++){
			if((argc == argnum_now + i) || (argv[argnum_now + i][0] == '-')){
				printf("Error : Invalid argument(Few number) [Mode 0(PCM data read)]\n");
				return(-1);
			}
		}
		if((argnum_now + i < argc) && (argv[argnum_now + i][0] != '-')){
			printf("Error : Invalid argument (Too many number) [Mode 0(PCM data read)]\n");
			return(-1);
		}
	}
	else if(mode == 1){
		for(i = 0; i < 1; i++){
			if((argc == argnum_now + i) || (argv[argnum_now + i][0] == '-')){
				printf("Error : Invalid argument(Few number) [Mode 1(PCM data write)]\n");
				return(-1);
			}
		}
		if((argnum_now + i < argc) && (argv[argnum_now + i][0] != '-')){
			printf("Error : Invalid argument (Too many number) [Mode 1(PCM data write)]\n");
			return(-1);
		}
	}
	else if(mode == 2){
		for(i = 0; i < 1; i++){
			if((argc == argnum_now + i) || (argv[argnum_now + i][0] == '-')){
				printf("Error : Invalid argument(Few number) [Mode 4(FPGA register read)]\n");
				return(-1);
			}
		}
		if((argnum_now + i < argc) && (argv[argnum_now + i][0] != '-')){
			printf("Error : Invalid argument (Too many number) [Mode 4(FPGA register read)]\n");
			return(-1);
		}
	}
	else if(mode == 3){
		for(i = 0; i < 2; i++){
			if((argc == argnum_now + i) || (argv[argnum_now + i][0] == '-')){
				printf("Error : Invalid argument(Few number) [Mode 5(FPGA register write)]\n");
				return(-1);
			}
		}
		if((argnum_now + i < argc) && (argv[argnum_now + i][0] != '-')){
			printf("Error : Invalid argument (Too many number) [Mode 5(FPGA register write)]\n");
			return(-1);
		}
	}
	else if(mode == 4){
		for(i = 0; i < 1; i++){
			if((argc == argnum_now + i) || (argv[argnum_now + i][0] == '-')){
				printf("Error : Invalid argument(Few number) [Mode 6(ADC gain set)]\n");
				return(-1);
			}
		}
		if((argnum_now + i < argc) && (argv[argnum_now + i][0] != '-')){
			printf("Error : Invalid argument (Too many number) [Mode 6(ADC gain set)]\n");
			return(-1);
		}
	}


	return(0);

}

