/*****************************************************************/
/*      ichtowav.cpp - creates wav files from  *******.ich       */
/*****************************************************************/
/******************* Declarations and Defines for BYTESWAP **********************/

//#define BYTESWAP							// if defined will enable byte ordering
									// if not defined, byte ordering is disabled
#define _LINUX_

#ifdef BYTESWAP

	unsigned long ByteSwap32 (unsigned long nLongNumber);
	unsigned short ByteSwap16 (unsigned short nValue);

	unsigned long sw_datalong;
	unsigned int sw_dataint;
	unsigned short sw_datashort;

	unsigned long ByteSwap32 (unsigned long nLongNumber)
	{
		unsigned long result32;

		result32 = ((nLongNumber&0x000000FF)<<24) + ((nLongNumber&0x0000FF00)<<8) + ((nLongNumber&0x00FF0000)>>8) 
					+ ((nLongNumber&0xFF000000)>>24);

		return(result32);
	}

	unsigned short ByteSwap16 (unsigned short nValue)
	{
		unsigned short result16;

		result16 = ((nValue>> 8)) | (nValue << 8);
		return (result16);
	}

#endif
/*
int ext_serch(char *ichfile){
                                                                                                                                               
        int st=0;
        int cnt;
                                                                                                                                               
        for( cnt=0 ; ; cnt++ ){
                if(*(ichfile+cnt)=='.') break;
        }
        if(*(ichfile+cnt+0)!='.') st=-1;
        if(*(ichfile+cnt+1)!='i') st=-1;
        if(*(ichfile+cnt+2)!='c') st=-1;
        if(*(ichfile+cnt+3)!='h') st=-1;
                                                                                                                                               
        return st;
}

void itoa( int ctr, char *wavcnt, int mode ){

	sprintf(wavcnt, "%d", ctr);

}

*/

/************************************************************************************/

#include<stdlib.h>
#include<stdio.h>
#include<string.h>
//#include<direct.h>
#include<math.h>


#ifdef _LINUX_
#define _MAX_PATH  512
#define _MAX_FNAME 512
#define _MAX_EXT   512
#define _MAX_DRIVE 32
#define _MAX_DIR   512
#endif



#define MAXSAMPLE	192						// maximum number of samples
#define MAXCHANNEL	64						// maximum number of channels
#define MAXNSEQ		65536					// sequence (0 to 65535)
#define MAXPKT		(65536*4)				// dependent
#define FDNUM		64						// maximum number of file desciptors
#define WAVCH		1						// wave channel

	struct	wave_header
	{
		char				riff[4];			/* constant: 'R' 'I' 'F' 'F' */

		unsigned int		nRiff_size;			/* dependent: nData_size + 38 */

		char				wave[4];			/* constant: 'W' 'A' 'V' 'E' */
		char				fmt[4];				/* constant: 'f' 'm' 't' ' ' */
	
		unsigned int		fmt_size;			/* constant: 16 */
		unsigned short int	wFormatTag;			/* constant: WAVE_FORMAT_PCM, 1*/
		unsigned short int	wChannels;			/* independent: 1 or 2 */

		unsigned int		nSamplesPerSec;		/* independent: standard values are 11025, 22050, 44100 */

		unsigned int		nAvgBytesPerSec;	/* dependent: nSamplesPerSec*(wBitsPerSample/8) */
		unsigned short int	wBlockAlign;		/* dependent: wBitsPerSample/8 */
		unsigned short int	wBitsPerSample;		/* dependent: 16*nChannels */

		char				data[4];			/* constant: 'd' 'a' 't' 'a' */
		unsigned int		nData_size;			/* independent */
	}; 

void InitializeArrays();
void rd_ich_payload(unsigned short nsamp, unsigned short nchan);
void transpose_pkt(unsigned short nsamp, unsigned short nchan);
void div_pkt(unsigned short ctr, unsigned short nsamp);
void wr_audio(unsigned short nsamp, unsigned short ctr);

//void wr_dummy(unsigned short ctr, unsigned short nsamp);					// for 0x0000 dummy data

void WriteLogFile(unsigned int totalpkt);									// write log file function

void WriteWavHeader(unsigned short ctr, const struct wave_header);
void createWavName(unsigned short ctr);
void HelpScreen();
	
unsigned short i, j, k, p, x, y, tmp, fill;
unsigned short mode, fctrtype;
unsigned short diff, i_diff, diffx, i_diffx;

unsigned int npacket, tpacket, miss, tmiss, ctrx, ctr;

unsigned short source[(MAXSAMPLE*MAXCHANNEL)];

//unsigned short tr_data[MAXSAMPLE][MAXCHANNEL];					// previous
unsigned short tr_data[MAXCHANNEL][MAXSAMPLE];						// corrected data arrangement

unsigned short div_data[(MAXSAMPLE*WAVCH)];

//unsigned short dummy[(MAXSAMPLE*WAVCH)];							// 0x0000 dummy data

char ichfile[_MAX_PATH];

char wavname[FDNUM][_MAX_PATH];
char wname[_MAX_FNAME] = "wavech";
char wavcnt[3];
char wavsuff[_MAX_EXT] = ".wav";

   char drive[_MAX_DRIVE];
   char dir[_MAX_DIR];
   char fname[_MAX_FNAME];
   char ext[_MAX_EXT];

char wavmask[_MAX_FNAME];
char maskname[_MAX_FNAME];
char des_dir[_MAX_PATH];


char *f_ptr[FDNUM];
char *modeptr;
char *log_option;
int indicator, createlog;

unsigned int ichversion;
unsigned int rate;
unsigned int hz;
unsigned int channel;
unsigned int nseq[MAXPKT];
unsigned short seqno[MAXNSEQ];

unsigned short nsamp, nchan;
unsigned short fctr_wav;
//unsigned short wav_pktsize, ich_plsize;
unsigned long wav_pktsize, ich_plsize, plnum;

unsigned int twavplsize, tichplsize;

struct wave_header my_wave;

FILE *ichstream;
FILE *mult_stream[FDNUM];
FILE *seqstream;

int ext_serch(char *ichfile){


        int st=0;
        int cnt;
 
        for( cnt=0 ; ; cnt++ ){
                if(*(ichfile+cnt)=='.') break;
        }
        if(*(ichfile+cnt+0)!='.') st=-1;
        if(*(ichfile+cnt+1)!='i') st=-1;
        if(*(ichfile+cnt+2)!='c') st=-1;
        if(*(ichfile+cnt+3)!='h') st=-1;


        return st;
}

void itoa( int ctr, char *wavcnt, int mode ){

        sprintf(wavcnt, "%d", ctr);

}

//---------------------------------------------------------------
int main(int argc, char **argv)
{
	if((argc < 3) && (argc != 1))
	{
		*argv++;
		modeptr = *argv;

		if((strcmp(modeptr,"/n") != 0) && (strcmp(modeptr,"/c") != 0) && (strcmp(modeptr,"/h") != 0) 
			&& (strcmp(modeptr,"/N") != 0) && (strcmp(modeptr,"/C") != 0) && (strcmp(modeptr,"/H") != 0)
			&& (strcmp(modeptr,"/?") != 0))
		{
				printf("Invalid mode.\n");
				exit(1);

		}else if((strcmp(modeptr,"/h") == 0) || (strcmp(modeptr,"/?") == 0) || (strcmp(modeptr,"/H") == 0))
			{
				HelpScreen();
				exit(1);

		}else if((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/N") == 0) 
					|| (strcmp(modeptr,"/C") == 0))
			{
				printf("Too few parameters.\n");
				exit(1);
			}
	}
	else if(argc > 4)
		{
			printf("Too many parameters.\n");
			exit(1);
		}
	else if(argc == 1)
		{
			HelpScreen();
			exit(1);
		}

	else if(argc == 4)
		{
			*argv++;
			modeptr = *argv;

			if((strcmp(modeptr,"/n") != 0) && (strcmp(modeptr,"/c") != 0) && (strcmp(modeptr,"/N") != 0)
				&& (strcmp(modeptr,"/C") != 0))
			{
				printf("Invalid mode.\n");
				exit(1);
			}

			*argv++;
			strcpy(ichfile, *argv);

//			_splitpath(ichfile, drive, dir, fname, ext);

//			if (strcmp(ext, ".ich") != 0)
			if(ext_serch(ichfile))
			{
				printf("Source is not an ICH file.\n");
				exit(1);
			}

			*argv++;
			log_option = *argv;

			if((strcmp(log_option,"/+y") != 0) && (strcmp(log_option,"/+Y") != 0) && (strcmp(log_option,"/-y") != 0)
				&& (strcmp(log_option,"/-Y") != 0))
			{
				printf("Invalid log option.\n");
				exit(1);
			}
		}


	else if(argc == 3)
		{
				printf("Too few parameters.\n");
				exit(1);
		}

 if((ichstream = fopen(ichfile, "rb" )) != NULL )
 {	
	   fseek(ichstream, 0, SEEK_SET);
	   fread(&ichversion, sizeof(unsigned int), 1, ichstream );

	   fseek(ichstream, 4, SEEK_SET);
	   fread(&rate, sizeof(unsigned int), 1, ichstream );

	   fseek(ichstream, 8, SEEK_SET);
	   fread(&channel, sizeof(unsigned int),1,ichstream);

	/*******************************************************************************/

	#ifdef BYTESWAP
	   sw_datalong = ByteSwap32(ichversion);
	   ichversion = sw_datalong; 
	#endif

		if(ichversion != 0x10000000)
		{
			printf("Could not read contents of ICH file.\n");
			exit(1);
		}

	#ifdef BYTESWAP
	   sw_dataint = (unsigned int) ByteSwap32((unsigned long)rate);
	   rate = sw_dataint;
	#endif

	//equivalent number of samples according to sampling rate setting
		switch( rate )
		{
			case 0x0000:
				nsamp = 192;
				hz = 48000;
				break;

			case 0x0001:
				nsamp = 128;
				hz = 32000;
				break;

			case 0x0002:
				nsamp = 64;
				hz = 16000;
				break;
        
			case 0x0003:
				nsamp = 32;
				hz = 8000;
				break;
       
			case 0x0004:
				nsamp = 192;
				hz = 44100;
				break;
        
			case 0x0005:
				nsamp = 96;
				hz = 22050;
				break;
        
			case 0x0006:
				nsamp = 48;
				hz = 11025;
				break;

			default:
				printf("Could not read contents of ICH file.\n");
				exit(1);
		}

	//equivalent number of channels according to channel setting

	#ifdef BYTESWAP
	   sw_dataint = (unsigned int) ByteSwap32((unsigned long)channel);
	   channel = sw_dataint;
	#endif

	if (channel != 0x0000){
		printf("Invalid channel number %d\n", channel);
		exit(1);
	}

	nchan = 16;

	/*******************************************************************************/

	fctr_wav = nchan;

	ich_plsize = (2*nsamp*nchan);				// payload size of 1 ich packet
	wav_pktsize = (2*WAVCH*nsamp);				// size of 1 wav packet

	fseek(ichstream, 18, SEEK_SET);	
	fread(&seqno[0], sizeof(unsigned short), i, ichstream);

		#ifdef BYTESWAP
			sw_datashort = ByteSwap16(seqno[0]);
			seqno[0] = sw_datashort;
		#endif

	fseek(ichstream, 20, SEEK_SET);				// set position to payload1, byte1 via ichstream
																	// prepare to read first payload
	npacket = 0;	
	seqstream = fopen(ichfile, "rb" );
	fseek(seqstream, 18, SEEK_SET);				// position of first seq. no. via seqstream
	fread(&nseq[npacket], sizeof(unsigned short), 1, seqstream);	// read sequence no. of 1st ich packet

		#ifdef BYTESWAP
			sw_datashort = ByteSwap16((unsigned short)nseq[npacket]);
			nseq[npacket] = sw_datashort;
		#endif

	while (!feof(seqstream))										// sequence number scan to get total number of packets
	{	
		npacket++;
		fseek(seqstream, (2+ich_plsize), SEEK_CUR);
		fread(&nseq[npacket], sizeof(unsigned short), 1, seqstream);

		#ifdef BYTESWAP
			sw_datashort = ByteSwap16((unsigned short)nseq[npacket]);
			nseq[npacket] = sw_datashort;
		#endif

	}

//	for (ctr=0; ctr<npacket; ctr++)
//		printf("packet(%d) = %d sequence no.\n", ctr, nseq[ctr]);	// display sequence number of all ich packets	
										// for checking

	ctrx=0;	
	miss=0;
	tmiss=0;

	for(ctrx=0; ctrx<(npacket-1); ctrx++)
	{
		diffx = nseq[ctrx+1] - nseq[ctrx];
		i_diffx = abs(diffx);
		miss = i_diffx-1;
		tmiss = tmiss + miss;										// calculate number of missing packets
	}

	tpacket = npacket + tmiss;

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		tichplsize = npacket * ich_plsize;
		twavplsize = npacket * wav_pktsize;
	}

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		tichplsize = npacket * ich_plsize;
		twavplsize = tpacket * wav_pktsize;
	}

	/*************************** create directory name *****************************/

//	strcpy(des_dir, drive);
//	strcat(des_dir, dir);
//	strcpy(maskname, fname);
//	strcat(maskname, "_wav");
//	strcat(des_dir, maskname);

        {
                int cnt;
                int cnt2;
                strcpy(des_dir, ichfile);
                for( cnt=0 ; ; cnt++ ){
                        if(*(des_dir+cnt)=='.') break;
                }
                for( cnt2=0 ; cnt2<4 ; cnt2++ ){
                        *(des_dir+cnt)='\0';
                }
        }
        strcat(des_dir, "_wav");


	/****************************** display data ************************************/

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
		printf("Performing normal mode. . .\n");

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
		printf("Performing confirm sequence mode. . .\n");

		printf("\n");
		printf("     Found number of channels in ICH file: %d channels\n", nchan);
		printf("     Found number of samples per channel: %d samples\n", nsamp);
		printf("     Found number of packets: %d packet(s)\n", npacket);
		printf("     ICH payload size per packet: %lu bytes\n", ich_plsize);
		printf("     Total ICH payload size: %d bytes\n", tichplsize);

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		printf("\n");
		printf("     Total WAV data size: %d bytes\n", twavplsize);
	}

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		printf("\n");
		printf("     Found sequence errors: %d error(s)\n", tmiss);

		if(tmiss !=0)
			printf("     Padding 0x0000 data to %d extra packet(s)\n", tmiss); 

		printf("\n");
		printf("     Total WAV data size: %d bytes\n", twavplsize);
	}

	if( mkdir(des_dir, 0777) == 0 )									// create directory
	{
		printf("\n");
		printf("     New folder succesfully created.\n");
		printf("     New folder for WAV files: %s\n", des_dir);
	}
	else
	{
		printf("\n");
		printf("     Path to WAV files: %s\n", des_dir);
	}

	/*********************************************************************************/

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
			plnum = npacket;

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
			plnum = tpacket;

		my_wave.riff[0] = 'R';
		my_wave.riff[1] = 'I';
		my_wave.riff[2] = 'F';
		my_wave.riff[3] = 'F';	

		my_wave.nRiff_size = (unsigned int)(((wav_pktsize * plnum) + 44) - 8);	
	
		my_wave.wave[0] = 'W';
		my_wave.wave[1] = 'A';
		my_wave.wave[2] = 'V';
		my_wave.wave[3] = 'E';

		my_wave.fmt[0] = 'f';
		my_wave.fmt[1] = 'm';
		my_wave.fmt[2] = 't';
		my_wave.fmt[3] = ' ';

		my_wave.fmt_size = 16;		// PCM 
		my_wave.wFormatTag = 1;
		my_wave.wChannels = 1;		// can be set to 1 for mono or 2 for strereo (default is 1 for this application)

		my_wave.nSamplesPerSec = hz;  

		my_wave.nAvgBytesPerSec = (my_wave.nSamplesPerSec * my_wave.wChannels * 2);		// 2 for 16bit
		my_wave.wBlockAlign = ((16/8) * my_wave.wChannels);			
		my_wave.wBitsPerSample = 16;													// for 16 bit
	
		my_wave.data[0] = 'd';
		my_wave.data[1] = 'a';	
		my_wave.data[2] = 't';	
		my_wave.data[3] = 'a';	

		my_wave.nData_size = (unsigned int)(wav_pktsize * plnum);		

		for(ctr=0; ctr<fctr_wav; ctr++)													// create header loop for wav
		{
			f_ptr[ctr] = &wavname[ctr][0];
			createWavName(ctr);
			WriteWavHeader(ctr, my_wave);
		} 

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		printf("     Writing files. . .");
		while(indicator != EOF)
		{
			rd_ich_payload(nsamp, nchan);
			transpose_pkt(nsamp, nchan);

			fctrtype = fctr_wav;

			for(ctr=0; ctr<fctrtype; ctr++)
			{
				div_pkt(ctr, nsamp);
				wr_audio(ctr, nsamp);
			}

			indicator=getc(ichstream);
			ungetc(indicator, ichstream);

			tmp++;
			fseek(ichstream, 4, SEEK_CUR);
		}
		printf("done!\n");
		printf("     %d WAV files written.\n", fctr_wav);
	}


	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		tmp=0;
		diff=0;
		printf("     Writing files. . .");
		while(indicator != EOF)
		{
			diff = (nseq[tmp+1] - nseq[tmp]);
			i_diff = abs(diff);

			rd_ich_payload(nsamp, nchan);
			transpose_pkt(nsamp, nchan);

			fctrtype = fctr_wav;

			for(ctr=0; ctr<fctrtype; ctr++)
			{			
				div_pkt(ctr, nsamp);
				wr_audio(ctr, nsamp);
			}

			if(((i_diff-1) != 0)&&(tmp <(npacket-1)))
			{
				for(fill=1; fill<=(i_diff-1); fill++)
					for(ctr=0; ctr<fctrtype; ctr++)
					{
						div_pkt(ctr, nsamp);						// to preserve channel correspondence. if removed
																	// only the final 4 channels of the ich file will be dummy

						wr_audio(ctr, nsamp);						// write data from previous packet as dummy data
					//	wr_dummy(ctr, nsamp);
					}
			}

			tmp++;
			fseek(ichstream, 4, SEEK_CUR);
			indicator=getc(ichstream);
			ungetc(indicator, ichstream);
		}
		printf("done!\n");
		printf("     %d WAV files written.\n", fctr_wav);
	}

	/*******************************************************************************/
/*
	printf("\n");
	printf("Create log file (y/n)? ");
	createlog = getchar();

	if(createlog == 'y' || createlog == 'Y')				// user input ...create log file?
	{
		WriteLogFile(tpacket);												// write log file
		printf("Log file created.\n");
	}
	else
	{
		printf("Log file not created.\n");
	}
*/

	if((strcmp(log_option,"/-y") == 0) || (strcmp(log_option,"/-Y") == 0))	// Prompt before creating log file
	{
		printf("\n");
		printf("Create log file (y/n)? ");
		createlog = getchar();

		if((createlog == 'y') || (createlog == 'Y'))			// user input ...create log file?
		{
			WriteLogFile(tpacket);				        // write log file
			printf("Log file created.\n");
		}
		else
		{
			printf("Log file not created.\n");
		}
	}

	if((strcmp(log_option,"/+y") == 0) || (strcmp(log_option,"/+Y") == 0))	
	{
		printf("\n");
		WriteLogFile(tpacket);						// write log file
		printf("Log file created.\n");
	}

	/*******************************************************************************/
	fclose(ichstream);
	fclose(seqstream);

	fctrtype = fctr_wav;

	for(i=0; i<fctrtype; i++)
		fclose(mult_stream[i]);

 }else
	{
		printf( "File not found or could not be opened.\n" );	
		exit(1);
	}
 
 return 0;

}		// end of main		


void InitializeArrays()
{
	memset(source, 0, (MAXSAMPLE*MAXCHANNEL));
	memset(tr_data, 0, (MAXSAMPLE*MAXCHANNEL));
	memset(div_data, 0, (MAXSAMPLE*WAVCH));
//	memset(dummy, 0, (MAXSAMPLE*WAVCH));
	memset(ichfile, 0, _MAX_PATH);
	memset(drive, 0, _MAX_DRIVE);
	memset(dir, 0, _MAX_DIR);
	memset(fname, 0, _MAX_FNAME);
	memset(ext, 0, _MAX_EXT);
	memset(nseq, 0, MAXPKT);
	memset(seqno, 0, MAXNSEQ);
}


void createWavName(unsigned short ctr)
{
	memset(wavname[ctr], 0, 12);
	itoa( ctr, wavcnt, 10 );

	strcpy(wavname[ctr], des_dir);
	strcat(wavname[ctr], "/");
	strcpy(wavmask, wname);
	strcat(wavmask, wavcnt);
	strcat(wavname[ctr], wavmask);
	strcat(wavname[ctr], wavsuff);

	if((mult_stream[ctr] = fopen(f_ptr[ctr], "wb" )) != NULL )
	{
	}else
	{
		printf( "Could not write file!\n" );
		exit(1);
	}
}


void WriteWavHeader(unsigned short ctr, const struct wave_header w)
{
	if((mult_stream[ctr] = fopen(f_ptr[ctr], "ab" )) != NULL )
	{
		
		fwrite(&w,sizeof(struct wave_header), 1, mult_stream[ctr]);

	}else
	{
		printf( "Could not write file!\n" );
		exit(1);
	}
}


void rd_ich_payload(unsigned short nsamp, unsigned short nchan)
{
	fseek(ichstream, 0, SEEK_CUR);
	for(i=0; i<(nsamp*nchan); i++)
	{
		fread(&source[i], sizeof(unsigned short), 1, ichstream);

		#ifdef BYTESWAP
			sw_datashort = ByteSwap16(source[i]);
			source[i] = sw_datashort;
		#endif
	}
}

/*
void transpose_pkt(unsigned short nsamp, unsigned short nchan)					// previous
{
	unsigned short m;
	m=0;

	for(i=0; i<nsamp; i++)
	{
		for (j=0; j<nchan; j++)
		{
			tr_data[i][j] = source[m];
			m++;
		}
	}
}
*/


void transpose_pkt(unsigned short nsamp, unsigned short nchan)				// corrected data arrangement
{
	unsigned short m;
	m=0;
	
	// the before 2ms
	for(i=0; i<nchan; i++)
	{
		for (j=0; j<(nsamp/2); j++)
		{
			tr_data[i][j] = source[m];
			m++;
		}
	}
	
	for(i=0; i<nchan; i++)
	{
		for (j=(nsamp/2); j<nsamp; j++)
		{
			tr_data[i][j] = source[m];
			m++;
		}
	}

}


/*
void div_pkt(unsigned short ctr, unsigned short nsamp)							// previous
{
	unsigned short functype;
	unsigned short z;
	unsigned short ch_start, ch_end;

	functype = WAVCH;

	z=0;

	ch_start=0+(functype*ctr);
	ch_end=functype+(functype*ctr);

	for(i=0; i<nsamp; i++)
	{
		for(j=ch_start; j<ch_end; j++)
		{
			div_data[z] = tr_data[i][j];
			z++;
		}
	}
}
*/


void div_pkt(unsigned short ctr, unsigned short nsamp)							// corrected data arrangement
{
	unsigned short functype;
	unsigned short z;
	unsigned short ch_start, ch_end;

	functype = WAVCH;

	z=0;

	ch_start=0+(functype*ctr);
	ch_end=functype+(functype*ctr);

	for(i=ch_start; i<ch_end; i++)
	{
		for(j=0; j<nsamp; j++)
		{
			div_data[z] = tr_data[i][j];
			z++;
		}
	}
}


void wr_audio(unsigned short ctr, unsigned short nsamp)
{
	unsigned short functype;

	functype = WAVCH;

	fseek(mult_stream[ctr], 0, SEEK_CUR);
	fwrite(&div_data, sizeof(unsigned short),(nsamp*functype), mult_stream[ctr]);
}

/*
void wr_dummy(unsigned short ctr, unsigned short nsamp)
{
	unsigned short functype;

	functype = WAVCH;

	fseek(mult_stream[ctr], 0, SEEK_CUR);

	for(i=0; i<(nsamp*functype); i++)
		dummy[i] = 0;

	fwrite(&dummy, sizeof(unsigned short), (nsamp*functype), mult_stream[ctr]);	
}
*/

void HelpScreen()
{
	printf("Translates an ICH file into WAV files\n");
	printf("\n");
	printf("ICHTOWAV [MODE] [SOURCE] [LOG OPTION]\n");
	printf("\n");
	printf("MODE\n");
	printf("\n");
	printf("   /N        Normal mode. Reads packets sequentially\n");
	printf("             and ignores missing sequence number.\n");
	printf("   /C        Confirm sequence mode. Creates extra packets with\n");
	printf("             dummy padding data for the missing sequence number.\n");
	printf("\n");
	printf("SOURCE       Path and name of target ICH file.\n");
	printf("\n");
	printf("LOG OPTION\n");
	printf("   /+Y       Create log file.\n");
	printf("   /-Y       Prompt before creating log file.\n");
}


void WriteLogFile(unsigned int totalpkt)
{
	FILE *logfile;
	
	char logpath[_MAX_PATH];
	unsigned short ctrl = 0;
	unsigned int xctr=0;
	unsigned int xcount=0;
	unsigned int logsize=482;
	int nbytes =0;

	strcpy(logpath, des_dir);
	strcat(logpath, "/");
	strcat(logpath, "lost.log");


  if( (logfile = fopen(logpath, "w+t" )) != NULL )
  {

	/************************** display data *****************************************/

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
		fprintf(logfile, "Log file for normal mode\n");

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
		fprintf(logfile, "Log file for confirm sequence mode\n");

		fprintf(logfile, "\n");
		fprintf(logfile, "     Found number of channels in ICH file: %d channels\n", nchan);
		fprintf(logfile, "     Found number of samples per channel: %d samples\n", nsamp);
		fprintf(logfile, "     Found number of packets: %d packet(s)\n", npacket);
		fprintf(logfile, "     ICH payload size per packet: %lu bytes\n", ich_plsize);
		fprintf(logfile, "     Total ICH payload size: %d bytes\n", tichplsize);

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		fprintf(logfile, "\n");
		fprintf(logfile, "     Total WAV payload size: %d bytes\n", twavplsize);
	}

		fprintf(logfile, "\n");
		fprintf(logfile, "     Found sequence errors: %d error(s)\n", tmiss);

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		if(tmiss !=0)
			fprintf(logfile, "     Padding 0x0000 data to %d extra packet(s)\n", tmiss); 

		fprintf(logfile, "\n");	
		fprintf(logfile, "     Total WAV payload size: %d bytes\n", twavplsize);
	}

		if( mkdir(des_dir, 0777) == 0 )									// create directory
		{
			fprintf(logfile, "\n");
			fprintf(logfile, "     New folder succesfully created.\n");
			fprintf(logfile, "     New folder for WAV files: %s\n", des_dir);
		}
		else
		{
			fprintf(logfile, "\n");
			fprintf(logfile, "     Path to WAV files: %s\n", des_dir);
		}

		fprintf(logfile, "\n");
		fprintf(logfile, "   Sequence number detail\n");

		
	/************************** Missing Sequence Number ****************************/
	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		while(xctr<totalpkt)
		{
			ctrl = xctr%65536;	
			if (nseq[xcount] == ctrl)
			{
//				fprintf(logfile, "     sequence no.(%d) : present. \n", ctrl);
				xcount++;
				xctr++;
			}
			else
			{
				nbytes = fprintf(logfile, "*   sequence no.(%d) : missing....... ignored.\n", ctrl);
				logsize = logsize+nbytes;
				if(logsize >= 1000000)
				{
					printf("Log file truncated.\n");
					fprintf(logfile, "\n---- logfile truncated.");
					break;
				}
				xctr++;		
			}
		}
	}

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		while(xctr<totalpkt)
		{
			ctrl = xctr%65536;
			if (nseq[xcount] == ctrl)
			{
//				fprintf(logfile, "     sequence no.(%d) : present. \n", ctrl);		
				xcount++;
				xctr++;
			}
			else
			{
				nbytes = fprintf(logfile, "*   sequence no.(%d) : missing....... dummy data padded.\n", ctrl);
				logsize = logsize+nbytes;
				if(logsize >= 1000000)
				{
					printf("Log file truncated.\n");
					fprintf(logfile, "\n---- logfile truncated.");
					break;
				}
				xctr++;		
			}
		}
	}


	fprintf(logfile, "\n\n");
	fprintf(logfile, "---- end of log -----");

	fclose(logfile);

	/*******************************************************************************/
  }else
  {
	  printf( "Problem creating log.\n" );
	  exit(1);
  }

}
